import React from "react";
import { ReactSortableTreeProps, ExtendedNodeData, NodeData, OnDragPreviousAndNextLocation } from "atroo-react-sortable-tree";
import { DataNode, DefaultDataItem, INodeRenderers, Loader, OnDraggedFinished, OnNodeSelected } from "./types";
import "atroo-react-sortable-tree/style.css";
import { FetchNodes } from ".";
/**
 * TODOS
 *
 * TODO: update reference to parent to after node was dragged (?)
 * TODO: get total count root children from response (?)
 * TODO: alow custom "canDrag", "canDrop", "onRowsRendered" functions to be passed (?)
 * TODO: performance optimizations (?)
 */
interface IVirtialTreeProps<T extends DefaultDataItem> extends Omit<ReactSortableTreeProps, "reactVirtualizedListProps" | "treeData" | "onChange"> {
    onDraggedFinished?: OnDraggedFinished<T>;
    onNodeSelected?: OnNodeSelected<T>;
    url: string;
    initalTreeData?: DataNode<T>[];
    loader?: Loader<T>;
    renderers?: INodeRenderers<T>;
    countOfRootItems?: number;
    onTreeDataChange?: (treeData: DataNode<T>[]) => void;
    canDragInterceptor?: (data: ExtendedNodeData) => boolean;
    canDropInterceptor?: (data: OnDragPreviousAndNextLocation & NodeData) => boolean;
    withoutDefaultDragContext: boolean;
}
export interface VirtualTreeRef<T extends DefaultDataItem> {
    toggleNode: (props: ToggleNodeProps<T>) => void;
    forceLoadCurrentSkeletons: () => void;
    treeData: DataNode<T>[];
    setTreeData: React.Dispatch<React.SetStateAction<DataNode<T>[]>>;
    fetchNodes: FetchNodes<T>;
}
interface ToggleNodeProps<T> {
    treeData: DataNode<T>[];
    path: Array<string | number>;
    expanded?: boolean;
}
export declare const VirtualTree: React.ForwardRefExoticComponent<IVirtialTreeProps<DefaultDataItem> & React.RefAttributes<VirtualTreeRef<DefaultDataItem>>>;
export {};
